var EngineState = {
    esStalled : 0,
    esStalling : 1,
    esStarting : 2,
    esStareted : 3
}

var RunningState = {
    rsCarStalled : 0,
    rsCarRunningUp : 1,
    rsCarRunning : 2,
    rsCarBraking : 3
}

//             1      2      3     4     R(not work now)
var gears = [2.785, 1.545, 1.000, 0.694, -3.9];

/*var $sketch = this.$query_interface('ot::js::sketch.get'),
    $world = this.$query_interface('ot::js::world.get')

var display_canvas = $sketch.create_canvas(-1, { x: 0, y: 0 }, {x: 0, y: 0 });*/

// torque samples
var torque_samples = [
    {rpm:0,trq:0}
    ,{rpm:1000,trq:137.0}
    ,{rpm:1250,trq:175.0}
    ,{rpm:1500,trq:204.0}
    ,{rpm:1750,trq:224.0}
    ,{rpm:2000,trq:236.0}
    ,{rpm:2250,trq:250.0}
    ,{rpm:2500,trq:258.0}
    ,{rpm:2750,trq:266.0}
    ,{rpm:3000,trq:272.0}
    ,{rpm:3250,trq:277.5}
    ,{rpm:3500,trq:281.5}
    ,{rpm:3750,trq:286.5}
    ,{rpm:4000,trq:288.0}
    ,{rpm:4250,trq:287.0}
    ,{rpm:4500,trq:283.0}
    ,{rpm:4750,trq:275.0}
    ,{rpm:5000,trq:259.0}
    ,{rpm:5250,trq:248.5}
    ,{rpm:5500,trq:237.0}
    ,{rpm:5750,trq:217.0}
    ,{rpm:6000,trq:188.0}
    ,{rpm:10000,trq:0.0}
];

/*var rpm_val = [859,919,983,1052,1126,1205,1289,1379,1476,1579,1690,1808,
                1935,2070,2215,2370,2536,2714,2904,3107,3324,3557,3806,4072,
                4357,4662,4988,5337,5711,6111];
*/
var rpm_val = [1025,3500,6000];

                
var sound_path = "sounds/";
var rpm_samples_count = rpm_val.length;

// CAR DEFINING CONSTANTS
var _max_swheel_angle = Math.PI* 3.25;
var _wheelbase = 2.625;
var _track = 1.435;
var _turning_radius =     5.85;
var _max_wheel_angle = Math.asin(_wheelbase/_turning_radius);
var _wheel_rad = 0.30764;
var _final_ratio = 4.3;
var _fwd_gears_count = 4;
var _idle_rpm = 600;
var _max_rpm = 6500;
var _upshift_rpm = 5200;
var _downshift_rpm = 2000;
var _brake_torque = 1775.0;
var _engine_brake_coef = 1.0/3.0;
var _engine_inertia = 0.035;
var _engine_max_torque = -1;

var _truboboost_impulse = 0;
    
var _rad_per_kmh = 0.01847995;
var _rad_per_rmp = 0.000483321946;
var _kmh_gauge_min = 0.0;
var _kmh_gauge_max = 260.0;
var _rpm_gauge_min = 0.0;
var _rpm_gauge_max = 8000.0;

var _starting_len_sec = 1.066;
var _starter_rpm = 1500.0;
var _switch_off_rpm = 100.0;
var _after_start_rpm = 300.0;
var _run_up_rpm = 1100.0;

var _wheels_count = 4;

var _engine_sound_master_gain = 1.0;

var turn_indicator_period = 0.75;

var _swheel_joint = -1;
var _speed_gauge_joint = -1;
var _rpm_gauge_joint = -1;
var _shift_lever_snd = -1;
var _shift_level_snd_src = -1;
var _act_clutch = -1;
var _act_throttle = -1;
var _act_brakes = -1;
var _act_steering = -1;
var _act_shift = -1;
var _act_handbrake = -1;
var _act_reverse = -1;
var _act_lights_passing = -1;
var _act_lights_main = -1;
var _act_lights_turn = -1;
var _act_lights_emer = -1;
var _act_turboboost = 0;
var rpm_snd_off = [];
var rpm_snd_on = [];
var rpm_src_off = [];
var rpm_src_on = [];
var _starter_sound = -1;
var    _starter_sound_source = -1; 
var _wheel_sound_sources = [];
var _skid_sound = -1;
var _aero_sound = -1;
var _aero_sound_source = -1;
var _dirtroll_sound = -1;
var _cobblestoneroll_sound = -1;
var _grassroll_sound = -1;
var _grassskid_sound = -1;
var _gravelroll_sound = -1;
var _gravelskid_sound = -1;
var _roadroll_sound = -1;
var _roadskid_sound = -1;
var _soundmat_table = [];

var _main_beam_mask = 0;
var _passing_beam_mask = 0;
var _brake_mask = 0;
var _rev_mask = 0;
var _left_turn_indicator_mask = 0;
var _right_turn_indicator_mask = 0;

var _steer_ax_params = {};

for (var i = 0; i < rpm_val.length; i++) {
        rpm_snd_off[i] = 0;
        rpm_snd_on[i] = 0;
        rpm_src_off[i] = 0;
        rpm_src_on[i] = 0;
}
    
//invoked only the first time the model is loaded, or upon reload
function init_chassis(param)
{    
    var len = torque_samples.length;
    for(var i = 0 ; i < len; i++){
        if(_engine_max_torque > torque_samples[i].trq){
            break;
        }else{
            _engine_max_torque = torque_samples[i].trq
        }
    }
    
    var par = eval(param);
    this.__proto__.drive_type = par.drive_type;
    
    var wheelparam = {
      radius: 0.3,                      // fly77    addjusted wheel radius so that wheel corectly touches ground 
      width: 0.325,
      suspension_max: 0.2,              // fly77   suspension max was too high   adjusted to 0.2
      suspension_min: -0.15,
      suspension_stiffness: 20.0,
      damping_compression: 0.15,
      damping_relaxation: 0.15,
      slip: 1.8,
      roll_influnce: 0.1,
    };

    this.__proto__.vehicle_params = {
        mass: 1475.0,
        steering_ecf: 60.0,
        centering_ecf: 10.0,
        com: {x: 0.0, y: -0.05, z: 0.2},
        steering_params: {
            radius: 0.17
        }
    };
    
    this.add_wheel("wheel_f_L", wheelparam);
    this.add_wheel("wheel_f_R", wheelparam);
    this.add_wheel("wheel_r_L", wheelparam);
    this.add_wheel("wheel_r_R", wheelparam);
    
    _speed_gauge_joint = this.get_geomob(0).get_joint("speed_gauge");
    _rpm_gauge_joint = this.get_geomob(0).get_joint("rpm_gauge");
    _swheel_joint = this.get_geomob(0).get_joint("steering_wheel");
    
    _starter_sound = this.load_sound("" + sound_path + "starter.ogg");
    _starter_sound_source = this.add_sound_emitter("EXHAUST");
    
    //sounds
    for (var i = 0; i < rpm_samples_count; i++) {
        rpm_snd_off[i] = this.load_sound("" + sound_path + rpm_val[i] + "_off.ogg");
        rpm_src_off[i] = this.add_sound_emitter("EXHAUST");
        rpm_snd_on[i] = this.load_sound("" + sound_path + rpm_val[i] + "_on.ogg");
        rpm_src_on[i] = this.add_sound_emitter("EXHAUST");
    };
    
    _shift_lever_snd = this.load_sound("" + sound_path + "shift.ogg");
    _shift_level_snd_src = this.add_sound_emitter("shift");
    
    
    _wheel_sound_sources = [
    {roll:this.add_sound_emitter("wheel_f_L"),skid:this.add_sound_emitter("wheel_f_L")},
    {roll:this.add_sound_emitter("wheel_f_R"),skid:this.add_sound_emitter("wheel_f_R")},
    {roll:this.add_sound_emitter("wheel_r_L"),skid:this.add_sound_emitter("wheel_r_L")},
    {roll:this.add_sound_emitter("wheel_r_R"),skid:this.add_sound_emitter("wheel_r_R")}
    ];
    
     _aero_sound_source = this.add_sound_emitter("CIV_Saloon_02_0_0.095");
    _aero_sound = this.load_sound("" + sound_path + "aero.ogg");
    
    _dirtroll_sound = this.load_sound  ("" + sound_path + "dirtroll.ogg");
    _cobblestoneroll_sound = this.load_sound  ("" + sound_path + "cobblestoneroll.ogg");
    _grassroll_sound = this.load_sound ("" + sound_path + "grassroll.ogg");
    _grassskid_sound = this.load_sound ("" + sound_path + "grassskid.ogg");
    _gravelroll_sound = this.load_sound("" + sound_path + "gravelroll.ogg");
    _gravelskid_sound = this.load_sound("" + sound_path + "gravelskid.ogg");
    _roadroll_sound = this.load_sound  ("" + sound_path + "roadroll.ogg");
    _roadskid_sound = this.load_sound  ("" + sound_path + "roadskid.ogg");
    
    // soundmat table construction
    /*
    
    TerrainMatDirt              = 0,
    TerrainMatGrass             = 1,
    TerrainMatMoss              = 2,
    TerrainMatRock              = 3,
    TerrainMatMud               = 4,
    TerrainMatGravel            = 5,
    TerrainMatAsphalt           = 6,
    TerrainMatAsphaltPaintWhite = 7,
    TerrainMatSand              = 8,
    TerrainMatForestFloor       = 9,
    TerrainMatConcrete          = 10,
    TerrainMatAsphaltPaintYellow = 11,
    TerrainMatCobbles           = 12,
    TerrainMatDirtDug           = 14,
    TerrainMatSnow              = 15,
    */
    
    _soundmat_table = [
        {roll:_dirtroll_sound,skid:_gravelskid_sound},                    //  TerrainMatDirt              = 0
        {roll: _grassroll_sound, skid: _grassskid_sound },                //     TerrainMatGrass             = 1
        {roll: _grassroll_sound, skid: _grassskid_sound },                //    TerrainMatMoss              = 2
        {roll: _gravelroll_sound, skid: _gravelskid_sound},                //  TerrainMatRock              = 3
        {roll:_dirtroll_sound,skid:_gravelskid_sound},                    //  TerrainMatMud               = 4
        {roll:_gravelroll_sound,skid:_gravelskid_sound},                //  TerrainMatGravel            = 5
        {roll: _roadroll_sound, skid: _roadskid_sound},                    //  TerrainMatAsphalt           = 6
        {roll: _roadroll_sound, skid: _roadskid_sound},                    //  TerrainMatAsphaltPaintWhite = 7
        {roll:_dirtroll_sound,skid:_gravelskid_sound},                    //  TerrainMatSand              = 8
        {roll: _grassroll_sound, skid: _grassskid_sound },                //  TerrainMatForestFloor       = 9
        {roll: _roadroll_sound, skid: _roadskid_sound},                    //  TerrainMatConcrete          = 10
        {roll: _roadroll_sound, skid: _roadskid_sound},                    //  TerrainMatAsphaltPaintYellow = 11  
        {roll: _cobblestoneroll_sound, skid: _roadskid_sound},            //  TerrainMatCobbles           = 12
        {roll: "",skid:""},                                                //  UNDEFINED MATERIAL             = 13            
        {roll:_dirtroll_sound,skid:_gravelskid_sound},                    //  TerrainMatDirtDug           = 14
        {roll:_dirtroll_sound,skid:_gravelskid_sound}                    //  TerrainMatSnow              = 15
    ]
    
    // actions 
    _steer_ax_params = { vel : 2.0, acc: 1.0, center : 2.0 };
    _act_clutch = this.register_axis("car/controls/clutch", { vel : 0x10000, acc: 0x10000, center : 0x10000 }, clutch_action, 0, 0);
    _act_throttle = this.register_axis("car/controls/power", {vel : 2.0, acc: 2.0, center : 2.0  }, throttle_action, 0, 0);
    _act_brakes = this.register_axis("car/controls/brake", { vel : 0x10000, acc: 0x10000, center : 0x10000 }, brake_action, 0, 0);
    _act_steering = this.register_axis("car/controls/steering", { vel : -1, acc: 50, center : -2 }, steering_action, 0, 0);
    _act_shift = this.register_axis("car/engine/shift", { vel : 0x10000, acc: 0x10000, center : 0x10000 }, shift_action, 0, 0);
    _act_handbrake = this.register_axis("car/controls/hand_brake", { vel : 0x10000, acc: 0x10000, center : 0x10000 }, handbrake_action, 0, 0);
    _act_reverse = this.register_axis("car/engine/reverse", { vel : 0x10000, acc: 0x10000, center : 0x10000 }, reverse_action, 0, 0);
    _act_lights_passing = this.register_switch("car/lights/passing",toggle_passing_lights_action);
    _act_lights_main = this.register_switch("car/lights/main",toggle_main_lights_action);
    _act_lights_turn = this.register_switch("car/lights/turn",toggle_turn_indicator_action);
    _act_lights_emer = this.register_switch("car/lights/emergency",toggle_emergency_lights_action);
    _act_turboboost = this.register_event("car/controls/turbo", turboboost_action);

    // lights 
    // passing lights 
    var fp = {size:0.1, angle:54, edge:0.08, fadeout:0.2, range:50};
    this.add_spot_light({x:0.33308,y:2.19972, z: 0.61301} , {y:1}, fp);
    this.add_spot_light({x:-0.32942,y:2.19972, z: 0.61301} , {y:1}, fp);
    // tail passing lights 
    fp = {size:0.25, angle:160, edge:0.8, fadeout:0.05, range:200, color:{x:1.0} };
    this.add_spot_light({x:-0.65811,y:-2.12541,z:0.80299}, {y:-1}, fp);
    this.add_spot_light({x:0.66177,y:-2.12541,z:0.80299}, {y:-1}, fp);
    _passing_beam_mask = 0x3f;
    
    
    // main lights
    fp = {size:0.165, angle:40, edge:0.08, fadeout:0.05, range:100 };
    var mask_offset = this.add_spot_light({x:-0.51307,y:2.13758,z:0.61152}, {y:1}, fp);
    this.add_spot_light({x:0.51673,y:2.13758,z:0.61152}, {y:1}, fp);
    _main_beam_mask = 0x3 << mask_offset;
    
    // reverse lights 
    fp = {size:0.165, angle:120, edge:0.8, fadeout:0.05, range:25 };
    mask_offset = this.add_spot_light({x:0.43766,y:-2.21447, z: 0.74608} , {y:-1}, fp);
    this.add_spot_light({x:-0.434,y:-2.21447, z:0.74608} , {y:-1}, fp);
    _rev_mask = 0x3 << mask_offset;
    
    //brake lights
    fp = {size:0.165, angle:120, edge:0.8, fadeout:0.05, range:100, color:{x:1.0} };
    mask_offset = this.add_spot_light({x:0.38196,y:-2.21447, z:0.80797} , {y:-1}, fp);
    this.add_spot_light({x:-0.3783,y:-2.21447, z: 0.80797} , {y:-1}, fp);
    this.add_spot_light({x:0.00183,y:-1.59356, z: 1.04282} , {y:-1}, fp);
    _brake_mask = 0x3 << mask_offset;
    
    // left turn indicator
    fp = {size:0.165, angle:120, edge:0.8, fadeout:0.05, range:20, color:{x:1.0,y:0.5} };
    mask_offset = this.add_spot_light({x:-0.69434,y:2.04313, z: 0.62029} , {x:-0.7071,y:0.7071}, fp);
    this.add_spot_light({x:-0.64466,y:-2.1406, z: 0.74487} , {x:-0.7071,y:-0.7071}, fp);
    _left_turn_indicator_mask = 0x3 << mask_offset
    
    // right turn indicator
    fp = {size:0.165, angle:120, edge:0.8, fadeout:0.05, range:20, color:{x:1.0,y:0.5} };
    mask_offset = this.add_spot_light({x:0.69664,y:2.04313, z: 0.62016} , {x:0.7071,y:0.7071}, fp);
    this.add_spot_light({x:0.64832,y:-2.1406, z: 0.74487} , {x:0.7071,y:-0.7071}, fp);
    _right_turn_indicator_mask = 0x3 << mask_offset
    
    return this.vehicle_params;
}

function process_engine_sound(rpm)
{
    
    for(var i = 0; i < rpm_samples_count; i++){
        this.rpm_pit[i] = rpm / rpm_val[i];
        this.rpm_vol[i] = 0.0;
    }
    
    if (rpm <= rpm_val[0]) {
        // only first sample
        this.rpm_vol[0] = 1.0;
    } else if (rpm < rpm_val[rpm_samples_count - 1]) {
        
        for (var i = 0; i < rpm_samples_count - 1; i++) {
            if (rpm > rpm_val[i] && rpm <= rpm_val[i + 1]) {
                var rpm_d = rpm_val[i+1] - rpm_val[i];
                var vol_l = (rpm_val[i+1] - rpm) / rpm_d;
                var vol_h = (rpm - rpm_val[i]) / rpm_d;
                
                this.rpm_vol[i] = vol_l;
                this.rpm_vol[i+1] = vol_h;
                
                break;
            } 
        }
    } else {
        this.rpm_vol[rpm_samples_count - 1] = 1.0;
    }
    
    for (var i = 0; i < rpm_samples_count; i++) {
        this.snd.set_pitch(rpm_src_off[i], this.rpm_pit[i]);
        this.snd.set_gain(rpm_src_off[i], _engine_sound_master_gain * this.rpm_vol[i] * (1.0 - this.engine_load));
        this.snd.set_pitch(rpm_src_on[i], this.rpm_pit[i]);
        this.snd.set_gain(rpm_src_on[i], _engine_sound_master_gain * this.rpm_vol[i] * this.engine_load);
    }
}

function get_torque(rpm){
    var len = torque_samples.length;
    
    for(i = 1; i < len; i++){
        if(torque_samples[i].rpm <= rpm){
            continue;
        }
        
        var t = (rpm - torque_samples[i-1].rpm) / (torque_samples[i].rpm - torque_samples[i-1].rpm);
        return torque_samples[i].trq * t +  torque_samples[i - 1].trq * (1 - t);
    }
    
    return 0;
}

function clutch_action(v,dt){
    this.clutch = 1.0 - v;
}

function throttle_action(v,dt){
    if(this.engine_state != EngineState.esStareted){
        return;
    }
    
    this.engine_load = v;
    
    if(v > 0 && this.parking_brake == 1.0 && this.engine_state == EngineState.esStareted){
        this.parking_brake = 0.0;
    }
}

function brake_action(v,dt){
    this.braking = v;
}

function steering_action(v,dt){
    this.target_steering = -v;
}

function steering_filter(dt){
    var speed = Math.abs(this.speed());
    var kmh = 3.6 * speed;//(Math.round(speed*100.0)/100.0);
    var coef = Math.min(1.0,1.02 * Math.exp(-kmh / this.vehicle_params.steering_ecf));
    
    this.steering = this.target_steering;
    //this.steering = ((this.target_steering > 0) ? 1 : -1) * Math.pow(Math.abs(this.target_steering), 1.0 + 0.5 * (kmh / this.vehicle_params.steering_ecf));
    //this.steering = this.target_steering * coef;
    /*var speed = Math.abs(this.speed());
    var kmh = 3.6f * speed;

    //steering coef for dynamic steering/centering speed (2% threshold)
    float2 speedcoef = float2(
        glm::min(1.0f, 1.02f * exp(-kmh / _chassis->vparams.steering_threshold)),
        exp(-kmh / _chassis->vparams.centering_threshold));
    */
    //var alpha = dt / (0.2 + dt);
    //this.steering = (1.0 - alpha)*this.steering+ alpha*this.required_steering;
    
    /*var speed = Math.abs(this.speed());
    var kmh = 3.6 * (Math.round(speed*100.0)/10.0);
    var is_centering = Math.abs(this.target_steering) < Math.abs(this.steering) && this.target_steering * this.steering >= 0;
    
    if(is_centering){
        var coef = Math.exp(-kmh / 10.0);
        var dval = this.target_steering - this.steering;
        this.steering += (Math.round(dval && dval/Math.abs(dval)))*_steer_ax_params.vel*dt* (1.0 - coef);
    }else{
        var coef = Math.min(1.0,1.02 * Math.exp(-kmh / 60.0));
        this.log(coef);
        var dval = this.target_steering - this.steering;
        this.steering += (Math.round(dval && dval/Math.abs(dval)))*_steer_ax_params.vel*dt* coef;
    }
    
    this.log(this.steering);*/

    /*var speed = Math.abs(this.speed());
    var kmh = 3.6 * (Math.round(speed*100.0)/100.0);
    var coef = 0.0;
    if(Math.abs(this.target_steering) < 0.001){
        coef = 1 - Math.exp(-kmh / 20.0);
    }else{
        coef = 1.02 * Math.exp(-kmh / 60.0);
    }
    
    var sign = this.target_steering && this.target_steering/Math.abs(this.target_steering);
    var cur_steer_sign = this.steering && this.steering/Math.abs(this.steering);
    var max_steer = Math.exp(-kmh/100);
    var max_steer_signed = sign * max_steer;
    max_steer = max_steer_signed==0? 0: max_steer;
    var steer_abs = Math.abs(this.steering);
    this.log("max_steer: " + max_steer);
    this.log("cur_steer: " + this.steering);
    
    if(max_steer < 0.001){
        this.steering = Math.max(max_steer, steer_abs - _steer_ax_params.vel*dt * coef )*cur_steer_sign;
    }else{
        this.steering = this.steering + _steer_ax_params.vel*dt * coef * this.target_steering
        this.steering = Math.min(Math.max(this.steering, -max_steer), max_steer);        
    }*/
    
}

function turboboost_action(){
    if(this.on_ground)
        this.extra_force (this.vehicle_params.com, {x:0,y:_truboboost_impulse,z:_truboboost_impulse});
}

function handbrake_action(v,dt){
    
    if(v == 0){
        return;
    }
    
    if(this.parking_brake == 1.0 ){
        this.parking_brake = 0.0;
    }else{
        this.parking_brake = 1.0;
    }
}

function reverse_action(v,dt){
    if(!this._visual_initialized){
        return;
    }
    
    if(v == 0){
        return;
    }
    
    if(this.gear == -1){
        this.shift_gear(0);
        this.light_mask(_rev_mask,false);
        this.tail_reverse_left_light = 0;
        this.tail_reverse_right_light = 0;
    }else{
        this.shift_gear(-1);
        this.light_mask(_rev_mask,true);
        this.tail_reverse_left_light = 0x40000000;
        this.tail_reverse_right_light = 0x40000000;
        
    }
}

function shift_action(v,dt){
    if(v == 0){
        return;
    }
    
    this.gear += v;
    
    if(this.gear < -1){
        this.gear = -1;
    }
    
    if(this.gear > _fwd_gears_count){
        this.gear = _fwd_gears_count;
    }
    
    this.shift_gear(this.gear);
}

function  toggle_passing_lights_action(v,dt){
    if(!this._visual_initialized){
        return;
    }
    
    if(v == 0){
        return;
    }
    
    if(this._light_mask & _passing_beam_mask ){
        this._light_mask = this._light_mask&!_passing_beam_mask;
        this.light_mask(_passing_beam_mask,false);
        this.tail_passing_left_light = 0;
        this.tail_passing_right_light = 0;
    }else{
        this._light_mask = this._light_mask | _passing_beam_mask;
        this.light_mask(_passing_beam_mask,true);
        this.tail_passing_left_light = 0x2000007f;
        this.tail_passing_right_light = 0x2000007f;
    }
}

function  toggle_main_lights_action(v,dt){
    if(v == 0){
        return;
    }

    if(this._light_mask & _main_beam_mask ){
        this._light_mask = this._light_mask&!_main_beam_mask;
        this.light_mask(_main_beam_mask,false);
    }else{
        this._light_mask = this._light_mask | _main_beam_mask;
        this.light_mask(_main_beam_mask,true);
    }
}

function  toggle_turn_indicator_action(v,dt){
    if(!this._visual_initialized){
        return;
    }
    
    if(this.turn_ind_on_left && this.turn_ind_on_right) // emergency on
        return;
    
    this.turn_ind_time = 0;
    this.light_mask(_left_turn_indicator_mask,false);
    this.light_mask(_right_turn_indicator_mask,false);    
    this.tail_turn_left_light = 0;
    this.tail_turn_right_light = 0;
    this.front_turn_left_light = 0;
    this.front_turn_right_light = 0;
    
    if(v == 0){
        this.turn_ind_on_left = false;
        this.turn_ind_on_right = false;
        
    } else if(v > 0 ){
        this.turn_ind_on_left = false;
        this.turn_ind_on_right = true;
    } else{
        this.turn_ind_on_left = true;
        this.turn_ind_on_right = false;
    }
}

function toggle_emergency_lights_action(v,dt){
    if(!this._visual_initialized){
        return;
    }
    
    this.turn_ind_time = 0;
    if(v <= 0){
        this.turn_ind_on_left = false;
        this.turn_ind_on_right = false;
        this.light_mask(_left_turn_indicator_mask,false);
        this.light_mask(_right_turn_indicator_mask,false);
        this.tail_turn_left_light = 0;
        this.tail_turn_right_light = 0;
        this.front_turn_left_light = 0;
        this.front_turn_right_light = 0;
    } else {
        this.turn_ind_on_left = true;
        this.turn_ind_on_right = true;    
    }
}


function shift_gear(gear){
    this.gear = gear;
    
    if(this.gear == 0){
        this.gear_idx = -1;
        this.fade("Gear: N");
    }else if(this.gear == -1){
        this.gear_idx = _fwd_gears_count;
        this.fade("Gear: R");
    }else{
        this.gear_idx = gear - 1;
        this.fade("Gear: " + this.gear);
    }
        
    this.snd.play(_shift_level_snd_src, _shift_lever_snd, false, false, true);
}

function init_visual(){
    this.dlm = this.body.create_dynamic_lightmap(64, 32);
    
    {
        // cuvacie left 0,0 4x4
        // stretavacie left 8,0 4x4
        // smerovka 8,8 4x4
        // brzdove 0,8 4x4
        
        this.dlm_tail_reverse_left = this.body.add_light_block(4,4,4,4);
        this.dlm_tail_reverse_right = this.body.add_light_block(20,4,4,4);
        this.dlm_tail_passing_left = this.body.add_light_block(12,4,4,4);
        this.dlm_tail_passing_right = this.body.add_light_block(28,4,4,4);
        this.dlm_tail_turn_left = this.body.add_light_block(12,12,4,4);
        this.dlm_tail_turn_right = this.body.add_light_block(28,12,4,4);
        this.dlm_front_turn_left = this.body.add_light_block(4,20,4,4);;
        this.dlm_front_turn_right = this.body.add_light_block(12,20,4,4);
        this.dlm_tail_brake_left = this.body.add_light_block(4,12,4,4);
        this.dlm_tail_brake_right = this.body.add_light_block(20,12,4,4);

        this.tail_reverse_left_light = 0;
        this.tail_reverse_right_light = 0;
        this.tail_turn_left_light = 0;
        this.tail_turn_right_light = 0;
        this.front_turn_left_light = 0;
        this.front_turn_right_light = 0;
        this.tail_passing_left_light = 0;
        this.tail_passing_right_light = 0;

    }
    
    this._visual_initialized = true;
}

//invoked for each new instance of the vehicle
function init_vehicle()
{
    var geom = this.get_geomob(0);
    
    this._visual_initialized = false;
    
    this.transmission_action = transmission_action;
    this.shift_action = shift_action;
    this.shift_gear = shift_gear;
    this.update_gauges = update_gauges;
    this.process_engine_sound = process_engine_sound;
    this.update_wheels = update_wheels;
    this.update_torque = update_torque;
    this.update_rpm = update_rpm; 
    this.update_turn_indicator = update_turn_indicator;
    this.steering_filter = steering_filter;
    this.init_visual = init_visual;
    
    this.engine_state = EngineState.esStalled;
    this.running_state = RunningState.rsCarStalled;
    this.speed_old = 0;
    this.engine_rpm = 0;
    this.engine_trq = 0;
    
    this.gear = 0;
    this.gear_idx = -1;
    this.engine_load = 0.0;
    this.steering = 0.0;
    this.target_steering = 0.0;
    this.braking = 0.0;
    this.clutch = 1.0;
    this.parking_brake = 1.0;

    this._starting_time = 0;
    
    this.body = this.get_geomob(0);
    
    var cam_fps = this.body.get_joint_local_pos(this.body.get_joint("cam_fps"));
    this.set_fps_camera_pos({x:-0.36139,y:-0.13955,z:1.0689});	

    // sounds
    this.rpm_vol = [];
    this.rpm_pit = [];

    for (var i = 0; i < rpm_val.length; i++) {
        this.rpm_vol[i] = 0;
        this.rpm_pit[i] = 0;
    }
    
    this.snd = this.sound();
    for (var i = 0; i < rpm_samples_count - 1; i++) {
        this.snd.set_ref_distance(rpm_src_off[i], 5.0);
        this.snd.set_ref_distance(rpm_src_on[i], 5.0);
    };
    
    this.snd.set_gain(_shift_level_snd_src,0.3);
    this.snd.set_gain(_starter_sound_source,0.2);
    this.snd.set_gain(_aero_sound_source,8);
    this.snd.play_loop(_aero_sound_source,_aero_sound);
    
    for(var i = 0; i < 4; i++){
        this.snd.set_gain(_wheel_sound_sources[i].roll,0.0);
        this.snd.set_gain(_wheel_sound_sources[i].skid,0.0);
    }
    
    this.wheel_data = [{mat: -1},{mat: -1},{mat: -1},{mat: -1}];
    
    this._light_mask = 0;
    this.turn_ind_time = 0;
    this.turn_ind_on_left = false;
    this.turn_ind_on_right = false;
}

//invoked when engine starts or stops
function engine(start)
{
    if (start) {
        this.engine_state = EngineState.esStarting;
        this.clutch = 0;
        this.engine_rpm = 0;
        this._time_started = 0.0;
        this._period = 0.0;        
        this.snd.play(_starter_sound_source,_starter_sound,false,false);
    } else {
        this.engine_state = EngineState.esStalling;
        this.wheel_force(-1,0);
        this.parking_brake = 1.0;
    }
}

function update_gauges(){
    // update rpm gauge
    if(_rpm_gauge_min < this.engine_rpm){
        this.body.rotate_joint_orig(_rpm_gauge_joint, (this.engine_rpm - _rpm_gauge_min) * _rad_per_rmp, {x:0,y:-18,z:0});    
    }else{
        this.body.rotate_joint_orig(_rpm_gauge_joint, 0, {x:0,y:-18,z:0});    
    }
    
    var cur_speed = Math.abs(this.speed() * 3.6);
    // update speed gauge
    if(_kmh_gauge_min < cur_speed){
        this.body.rotate_joint_orig(_speed_gauge_joint, (cur_speed - _kmh_gauge_min) * _rad_per_kmh, {x:0,y:-18,z:0});    
    }
};

//invoked each frame to handle the inputs and animate the model
function update_frame(dt, engine, brake, steering,parking)
{
   /* this.log("Engine load: " + this.engine_load * 100.0 + "%");
    this.log("Breaks: " + this.braking * 100.0 + "%");
    this.log("Steering: " + this.steering * 100.0 + "%");
    this.log("Clutch: " + this.clutch * 100.0 + "%");*/
    
    
    if(!this._visual_initialized){
        this.init_visual();
    }
        
    this.body.rotate_joint_orig(_swheel_joint, this.steering * _max_swheel_angle, {x:0,y:0,z:73});
    this.animate_wheels();
    this.update_gauges();
    if(this.braking > 0.1){
        this.light_mask(_brake_mask,true);
        this.body.turn_on_block(this.dlm_tail_brake_left, 0x40000000);
        this.body.turn_on_block(this.dlm_tail_brake_right, 0x40000000);

    }else{
        this.light_mask(_brake_mask,false);
        this.body.turn_on_block(this.dlm_tail_brake_left, 0x00000000);
        this.body.turn_on_block(this.dlm_tail_brake_right, 0x00000000);
    }
    
    this.update_turn_indicator(dt);
    
    this.body.turn_on_block(this.dlm_tail_turn_left, this.tail_turn_left_light);
    this.body.turn_on_block(this.dlm_tail_turn_right, this.tail_turn_right_light);
    this.body.turn_on_block(this.dlm_front_turn_left, this.front_turn_left_light);
    this.body.turn_on_block(this.dlm_front_turn_right, this.front_turn_right_light);
    this.body.turn_on_block(this.dlm_tail_reverse_left, this.tail_reverse_left_light);
    this.body.turn_on_block(this.dlm_tail_reverse_right, this.tail_reverse_right_light);
    this.body.turn_on_block(this.dlm_tail_passing_left, this.tail_passing_left_light);
    this.body.turn_on_block(this.dlm_tail_passing_right,this.tail_passing_right_light);
    
    // update display
    /*$sketch.make_canvas_active(display_canvas);
    var screen_size = $world.screen_size();
    $sketch.set_canvas_2d_offset({ x: screen_size.x - 280, y: screen_size.y - 65 });
    $sketch.clear_canvas();
    $sketch.set_canvas_font('ui/xolonium_50_bold.fnt');
    var speed_str = Math.abs(this.speed() * 3.6).toFixed(0);
    $sketch.draw_text({ x: (3 - speed_str.length) * 40, y: 0 }, 0xbfffbfbf, speed_str + 'km/h');*/
}

function simulation_step(dt){
    this.steering_filter(dt);
    this.steer(0, this.steering * _max_wheel_angle);
    this.steer(1, this.steering * _max_wheel_angle);
    
    var gear_ratio = 0.0;
    var engine_brake = 0.0;
    
    if(this.gear_idx != -1){
        gear_ratio = gears[this.gear_idx];
    }
    
    if(this.engine_state == EngineState.esStarting){
        this._starting_time += dt;
        if(this._starting_time > _starting_len_sec){
            if(this.engine_rpm < 0.001){
                for (var i = 0; i < rpm_samples_count; i++) {
                    this.rpm_vol[i] = 0.0;
                    this.snd.play_loop(rpm_src_off[i], rpm_snd_off[i]);
                    this.snd.play_loop(rpm_src_on[i], rpm_snd_on[i]);
                }
                
                this.engine_rpm = _after_start_rpm;
                this.engine_load = 0.9;
            }
            
            this.update_torque(dt);
            this.update_rpm(dt);
            this.process_engine_sound(this.engine_rpm);     
            
            if(_starter_rpm - this.engine_rpm < 10.0){
                this.engine_state = EngineState.esStareted;
                this.engine_load = 0.0;
            }
        }
    }
    else if(this.engine_state == EngineState.esStareted){
        var alpha = dt / (0.2 + dt);
        if(this._starting_time > 0){
            this._starting_time = 0;
        }
        
        if(this.running_state == RunningState.rsCarStalled){
            this.engine_rpm = (1.0 - alpha) * this.engine_rpm + alpha*_idle_rpm;
            if(this.engine_load > 0.001){
                this.running_state = RunningState.rsCarRunningUp;
                //this.log("Stall -> RunningUp");
            }
        }else{
            var wd1 = 0; this.wheel(2);
            var wd2 = 0; this.wheel(3);
            if(this.drive_type == 0){  
                wd1 = this.wheel(2);
                wd2 = this.wheel(3);
            }else if(this.drive_type == 1){
                wd1 = this.wheel(0);
                wd2 = this.wheel(1);
            }
            
            var wheel_rpm = Math.max(wd1.rpm,wd2.rpm) * gear_ratio * _final_ratio; 
            var desired_rpm = this.engine_load * (_max_rpm - _idle_rpm) +  _idle_rpm;
                    
            this.transmission_action(wheel_rpm,desired_rpm);
            
            var engine_torque = 0;
            
            if(this.running_state == RunningState.rsCarRunningUp){
                this.engine_rpm = (1.0 - alpha) * this.engine_rpm + alpha*Math.min(desired_rpm,_run_up_rpm);
                engine_torque = get_torque(this.engine_rpm);
                
                if(this.engine_rpm - wheel_rpm < 10){
                    this.running_state = RunningState.rsCarRunning;
                    //this.log("RunningUp -> Running");
                }
                
                if(this.engine_load < 0.001){
                    this.running_state = RunningState.rsCarStalled;
                    engine_torque = 0
                    //this.log("RunningUp -> Stalled");
                }
            }else if(this.running_state == RunningState.rsCarRunning){
                this.engine_rpm = (1.0 - alpha) * this.engine_rpm + alpha*wheel_rpm;
                
                engine_torque = get_torque(this.engine_rpm);
                if(this.engine_rpm < _idle_rpm){
                    this.running_state = RunningState.rsCarStalled;
                    engine_torque = 0
                    //this.log("Running -> Stalled");
                }
            }
            
            var force_to_apply = (engine_torque*gear_ratio*_final_ratio) / _wheel_rad;
            force_to_apply *= 0.5;
            if(desired_rpm >= wheel_rpm){
                if(this.drive_type == 0){
                    this.wheel_force(2,force_to_apply);
                    this.wheel_force(3,force_to_apply);
                }else if(this.drive_type == 1){
                    this.wheel_force(0,force_to_apply);
                    this.wheel_force(1,force_to_apply);
                }
            }
            else{
                if(this.drive_type == 0){
                    this.wheel_force(2,0);
                    this.wheel_force(3,0);
                }else if(this.drive_type == 1){
                    this.wheel_force(0,0);
                    this.wheel_force(1,0);
                }
                engine_brake = _engine_brake_coef * force_to_apply;
            }
        }
        
        this.process_engine_sound(this.engine_rpm);
    }
    else if(this.engine_state == EngineState.esStalling){    
        var alpha = dt / (0.2 + dt);
        this.engine_rpm = (1.0 - alpha) * this.engine_rpm;        
        this.process_engine_sound(this.engine_rpm);     

        if(this.engine_rpm < _switch_off_rpm){
            this.engine_state = EngineState.esStalled;
            this.engine_rpm = 0;
            for (var i = 0; i < rpm_samples_count; i++) {
                this.rpm_vol[i] = 0.0;
                this.snd.stop(rpm_src_off[i]);
                this.snd.stop(rpm_src_on[i]);
            }
        }
    }
    
    this.wheel_brake(0, (_brake_torque * this.braking / _wheel_rad));
    this.wheel_brake(1, _brake_torque * this.braking / _wheel_rad);
    this.wheel_brake(2, (_brake_torque * (this.braking + this.parking_brake)/ _wheel_rad) + engine_brake);
    this.wheel_brake(3, (_brake_torque * (this.braking + this.parking_brake) / _wheel_rad) + engine_brake);
    
    this.update_wheels(dt);
    
   this.snd.set_gain(_aero_sound_source,5*Math.pow(Math.abs(this.speed()) / 83.33333,2));
    //this.log(Math.pow(Math.abs(this.speed()) / 83.33333,2));*/
    

}

function transmission_action(wheels_rpm,desired_rpm){
    if(this.gear == -1){
        return;        
    }else if(this.gear == 0){
        if(desired_rpm > _idle_rpm){
            this.shift_gear(1);
        }
    }else if(this.gear == 1){
        if(wheels_rpm > _upshift_rpm){
            this.shift_action(1);
        }
        
        if(wheels_rpm < _idle_rpm && this.running_state != RunningState.rsCarRunningUp){
            this.shift_gear(0);
        }
        
    }else{
        if(wheels_rpm > _upshift_rpm && this.gear < _fwd_gears_count){
            this.shift_action(1);
        }
        
        if(wheels_rpm < _downshift_rpm){
            this.shift_action(-1);
        }
    }
}

function update_wheels(dt){
    this.on_ground = true;
    for(i = 0; i < _wheels_count; i++){
        var wd = this.wheel(i);
        if(this.wheel_data[i].mat != wd.material){
            this.wheel_data[i].mat = wd.material;
            this.snd.play_loop(_wheel_sound_sources[i].skid,_soundmat_table[wd.material].skid);
            this.snd.play_loop(_wheel_sound_sources[i].roll,_soundmat_table[wd.material].roll);
        }
        
        var master_gain = ((this.speed()<30.0)?this.speed()/30.0:1.0) *0.02;
        
        var skid = Math.abs((wd.skid / 20.));
        skid = (skid > 1.0)? 1.0 : skid;
        
        this.snd.set_gain(_wheel_sound_sources[i].skid,wd.contact?skid*0.2:0.0);
        this.snd.set_gain(_wheel_sound_sources[i].roll,wd.contact?(1.0 - skid)*master_gain:0.0);
        
        if(!wd.contact)
            this.on_ground = false;
    }
};

function update_torque(dt){
    if (this.engine_rpm > _max_rpm) {
        this.engine_rpm = _max_rpm;
        this.engine_torque = 0;
    } else {
        var max_torqe = get_torque(this.engine_rpm);
        var static_friction = 0.1;
        var engine_brake = _engine_max_torque * _engine_brake_coef * (static_friction + (1.0 - static_friction)*(this.engine_rpm) / (_max_rpm));
        this.engine_torque = (max_torqe + engine_brake) * this.engine_load;
        if(this.engine_rpm > _idle_rpm){
            this.engine_torque -= engine_brake;
        }
    }
}

function update_rpm(dt){
    this.engine_rpm += (this.engine_torque / _engine_inertia)* dt;
}

function update_turn_indicator(dt){
    if(!this._visual_initialized){
        return;
    }
    
    if(!this.turn_ind_on_right && !this.turn_ind_on_left){
        return;
    }
    
    this.turn_ind_time += dt;
    this.turn_ind_time = (this.turn_ind_time > turn_indicator_period)? this.turn_ind_time - turn_indicator_period:this.turn_ind_time;
    
    if(this.turn_ind_time > turn_indicator_period*0.5){
        this.light_mask(_left_turn_indicator_mask,false);
        this.light_mask(_right_turn_indicator_mask,false);
        this.tail_turn_left_light = 0;
        this.tail_turn_right_light = 0;
        this.front_turn_left_light = 0;
        this.front_turn_right_light = 0;
    }else{
        this.light_mask(_left_turn_indicator_mask,this.turn_ind_on_left);
        this.light_mask(_right_turn_indicator_mask,this.turn_ind_on_right);
        if(this.turn_ind_on_left){
            this.tail_turn_left_light = 0x40000000;
            this.front_turn_left_light = 0x40000000;
            
        }
            
        if(this.turn_ind_on_right){
            this.tail_turn_right_light = 0x40000000;
            this.front_turn_right_light = 0x40000000;
        }
            
    }
}
